#!<PERL>

require 5.000;

my $VERSION = '$Revision: 1.1 $ ';
my $PROGRAM = "report_areas_changes";

use strict;

# Common configuration for perl scripts
##############################################################################
#
# $Id: report_areas_changes.pl,v 1.1 2002/04/27 01:02:10 dyff Exp $
#
# Perl functions to read FIDOGATE config file,
# included by <INCLUDE config.pl> when running subst.pl
#

my %CONFIG;
undef %CONFIG;

my %CONFIG_default =
    (
##Automatically generated by subst.pl, DO NOT EDIT!!!##
	"logdir", "/var/log/fidogate",
	"aliases", "%C/aliases",
	"outpkt_news", "%S/outpkt/news",
	"newsvardir", "/var/lib/news",
	"seq_pack", "%V/seq/pack",
	"routing", "%C/routing",
	"outpkt_mail", "%S/outpkt/mail",
	"areas", "%C/areas",
	"spooldir", "/var/spool/fidogate",
	"toss_bad", "%S/toss/bad",
	"outrfc_news", "%S/outrfc/news",
	"toss_toss", "%S/toss/toss",
	"ifmaildir", "/usr/lib/ifcico",
	"history", "%V/history",
	"passwd", "%C/passwd",
	"seq_tick", "%V/seq/tick",
	"seq_ff", "%V/seq/ff",
	"outrfc_mail", "%S/outrfc/mail",
	"config_gate", "%C/fidogate.conf",
	"libdir", "/usr/lib/fidogate",
	"toss_route", "%S/toss/route",
	"seq_pkt", "%V/seq/pkt",
	"bindir", "/usr/lib/fidogate/bin",
	"ftpinbound", "/var/spool/bt/ftpin",
	"lock_history", "history",
	"logfile", "%G/log",
	"seq_news", "%V/seq/news",
	"uplinks", "%C/uplinks",
	"toss_pack", "%S/toss/pack",
	"outpkt", "%S/outpkt",
	"lockdir", "/var/lock/fidogate",
	"vardir", "/var/lib/fidogate",
	"charsetmap", "%L/charset.bin",
	"newsspooldir", "/var/spool/news/articles",
	"seq_mail", "%V/seq/mail",
	"inbound", "/var/spool/bt/in",
	"acl", "%C/acl",
	"btbasedir", "/var/spool/bt",
	"tick_hold", "%B/tick",
	"seq_toss", "%V/seq/toss",
	"hosts", "%C/hosts",
	"newslibdir", "/usr/lib",
	"seq_split", "%V/seq/split",
	"spyes", "%C/spyes",
	"configdir", "/etc/fidogate",
	"newsetcdir", "/etc/news",
	"uuinbound", "/var/spool/bt/uuin",
	"config_main", "%C/fidogate.conf",
	"seq_msgid", "%V/seq/msgid",
	"packing", "%C/packing",
	"pinbound", "/var/spool/bt/pin",
     );
my %CONFIG_abbrev =
    (
##Automatically generated by subst.pl, DO NOT EDIT!!!##
	"B", "btbasedir",
	"G", "logdir",
	"C", "configdir",
	"L", "libexecdir",
	"N", "bindir",
	"V", "vardir",
	"K", "lockdir",
	"U", "uuinbound",
	"S", "spooldir",
	"P", "pinbound",
	"I", "inbound",
     );



sub CONFIG_read {
    my($file) = @_;
    my($key, $arg);
    local *C;

    $file = &CONFIG_expand($file);

    open(C,"$file") || die "config.pl: can't open config file $file\n";
    while(<C>) {
	chop;
	next if( /^\s*\#/ );	# comments
	next if( /^\s*$/  );	# empty
	s/\s*$//;		# remove trailing white space
	s/^\s*//;		# remove leading white space
	($key,$arg) = split(' ', $_, 2);
	$key =~ tr/A-Z/a-z/;
	&CONFIG_read($arg) if($key eq "include");
	$CONFIG{$key} = $arg if(!$CONFIG{$key});
    }
    close(C);
}


sub CONFIG_get1 {
    my($key) = @_;
    my($ukey);

    $ukey = $key;
    $ukey =~ tr/a-z/A-Z/;
    return $ENV{"FIDOGATE_$ukey"} if($ENV{"FIDOGATE_$ukey"});

    return $CONFIG{$key} if($CONFIG{$key});
    return $CONFIG_default{$key};
}


sub CONFIG_get {
    my($key) = @_;
    my($ret);
    my($exp);

    $key =~ tr/A-Z/a-z/;
    return &CONFIG_expand( &CONFIG_get1($key) );
}


sub CONFIG_expand {
    my($v) = @_;
    my($exp);

    if($v =~ /^%([A-Z])/) {
	$exp = &CONFIG_get1($CONFIG_abbrev{$1});
	$v =~ s/^%./$exp/;
    }

    return $v;
}


sub CONFIG_debug {    
    my($key);

    for $key (keys %CONFIG) {
	print "$key = $CONFIG{$key} -> ", &CONFIG_get($key), "\n";
    }
}

##############################################################################


my $logdir = CONFIG_get("LOGDIR");
